---
title: Range
slug: Web/API/Range
tags:
  - API
  - DOM
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>Range</code></strong> interface represents a fragment of a document that can contain nodes and parts of text nodes.</p>

<p>A range can be created by using the {{ domxref("Document.createRange()") }} method. Range objects can also be retrieved by using the {{ domxref("Selection/getRangeAt", "getRangeAt()") }} method of the {{ domxref("Selection") }} object or the {{domxref("Document/caretRangeFromPoint", "caretRangeFromPoint()")}} method of the {{domxref("Document")}} object.</p>

<p>There also is the {{domxref("Range.Range()", "Range()")}} constructor available.</p>

<h2 id="Properties">Properties</h2>

<p><em>There are no inherited properties.</em></p>

<dl>
 <dt>{{domxref("Range.collapsed")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Boolean")}} indicating whether the range's start and end points are at the same position.</dd>
 <dt>{{domxref("Range.commonAncestorContainer")}} {{readonlyInline}}</dt>
 <dd>Returns the deepest {{ domxref("Node") }} that contains the <code>startContainer</code> and <code>endContainer</code> nodes.</dd>
 <dt>{{domxref("Range.endContainer")}} {{readonlyInline}}</dt>
 <dd>Returns the {{ domxref("Node") }} within which the <code>Range</code> ends.</dd>
 <dt>{{domxref("Range.endOffset")}} {{readonlyInline}}</dt>
 <dd>Returns a number representing where in the <code>endContainer</code> the <code>Range</code> ends.</dd>
 <dt>{{domxref("Range.startContainer")}} {{readonlyInline}}</dt>
 <dd>Returns the {{ domxref("Node") }} within which the <code>Range</code> starts.</dd>
 <dt>{{domxref("Range.startOffset")}} {{readonlyInline}}</dt>
 <dd>Returns a number representing where in the <code>startContainer</code> the <code>Range</code> starts.</dd>
</dl>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{ domxref("Range.Range()", "Range()") }} {{experimental_inline}}</dt>
 <dd>Returns a <code>Range</code> object with the global {{domxref("Document")}} as its start and end.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>There are no inherited methods.</em></p>

<dl>
 <dt>{{ domxref("Range.setStart()")}}</dt>
 <dd>Sets the start position of a <code>Range</code>.</dd>
 <dt>{{ domxref("Range.setEnd()")}}</dt>
 <dd>Sets the end position of a <code>Range</code>.</dd>
 <dt>{{ domxref("Range.setStartBefore()")}}</dt>
 <dd>Sets the start position of a <code>Range</code> relative to another {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.setStartAfter()")}}</dt>
 <dd>Sets the start position of a <code>Range</code> relative to another {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.setEndBefore()")}}</dt>
 <dd>Sets the end position of a <code>Range</code> relative to another {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.setEndAfter()")}}</dt>
 <dd>Sets the end position of a <code>Range</code> relative to another {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.selectNode()")}}</dt>
 <dd>Sets the <code>Range</code> to contain the {{ domxref("Node") }} and its contents.</dd>
 <dt>{{ domxref("Range.selectNodeContents()")}}</dt>
 <dd>Sets the <code>Range</code> to contain the contents of a {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.collapse()")}}</dt>
 <dd>Collapses the <code>Range</code> to one of its boundary points.</dd>
 <dt>{{ domxref("Range.cloneContents()")}}</dt>
 <dd>Returns a {{ domxref("DocumentFragment") }} copying the nodes of a <code>Range</code>.</dd>
 <dt>{{ domxref("Range.deleteContents()")}}</dt>
 <dd>Removes the contents of a <code>Range</code> from the {{ domxref("Document") }}.</dd>
 <dt>{{ domxref("Range.extractContents()")}}</dt>
 <dd>Moves contents of a <code>Range</code> from the document tree into a {{ domxref("DocumentFragment") }}.</dd>
 <dt>{{ domxref("Range.insertNode()")}}</dt>
 <dd>Insert a {{ domxref("Node") }} at the start of a <code>Range</code>.</dd>
 <dt>{{ domxref("Range.surroundContents()")}}</dt>
 <dd>Moves content of a <code>Range</code> into a new {{ domxref("Node") }}.</dd>
 <dt>{{ domxref("Range.compareBoundaryPoints()")}}</dt>
 <dd>Compares the boundary points of the <code>Range</code> with another <code>Range</code>.</dd>
 <dt>{{ domxref("Range.cloneRange()")}}</dt>
 <dd>Returns a <code>Range</code> object with boundary points identical to the cloned <code>Range</code>.</dd>
 <dt>{{ domxref("Range.detach()")}}</dt>
 <dd>Releases the <code>Range</code> from use to improve performance.</dd>
 <dt>{{ domxref("Range.toString()")}}</dt>
 <dd>Returns the text of the <code>Range</code>.</dd>
 <dt>{{ domxref("Range.compareNode()")}} {{ Obsolete_inline }}{{non-standard_inline}}</dt>
 <dd>Returns a constant representing whether the {{domxref("Node")}} is before, after, inside, or surrounding the range.</dd>
 <dt>{{ domxref("Range.comparePoint()")}} {{experimental_inline}}</dt>
 <dd>Returns -1, 0, or 1 indicating whether the point occurs before, inside, or after the <code>Range</code>.</dd>
 <dt>{{ domxref("Range.createContextualFragment()")}}{{experimental_inline}}</dt>
 <dd>Returns a {{ domxref("DocumentFragment") }} created from a given string of code.</dd>
 <dt>{{ domxref("Range.getBoundingClientRect()") }} {{experimental_inline}}</dt>
 <dd>Returns a {{ domxref("DOMRect") }} object which bounds the entire contents of the <code>Range</code>; this would be the union of all the rectangles returned by {{ domxref("range.getClientRects()") }}.</dd>
 <dt>{{ domxref("Range.getClientRects()") }} {{experimental_inline}}</dt>
 <dd>Returns a list of {{ domxref("DOMRect") }} objects that aggregates the results of {{ domxref("Element.getClientRects()") }} for all the elements in the <code>Range</code>.</dd>
 <dt>{{ domxref("Range.intersectsNode()")}} {{experimental_inline}}</dt>
 <dd>Returns a <code>boolean</code> indicating whether the given node intersects the <code>Range</code>.</dd>
 <dt>{{ domxref("Range.isPointInRange()")}} {{experimental_inline}}</dt>
 <dd>Returns a <code>boolean</code> indicating whether the given point is in the <code>Range</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#interface-range', 'Range')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Do not use <code>RangeException</code> anymore, use <code>DOMException</code> instead.<br>
    Made the second parameter of <code>collapse()</code> optional.<br>
    Added the methods <code>isPointInRange()</code>, <code>comparePoint()</code>, and <code>intersectsNode()</code>.<br>
    Added the constructor <code>Range()</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM Parsing', '#extensions-to-the-range-interface', 'Extensions to Range')}}</td>
   <td>{{Spec2('DOM Parsing')}}</td>
   <td>Added the method <code>createContextualFragment()</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSSOM View', '#extensions-to-the-range-interface', 'Extensions to Range')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
   <td>Added the methods <code>getClientRects()</code> and <code>getBoundingClientRect()</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level-2-Range-Interface', 'Range')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
